// variante interactive de polyfbm
// pierre cubaud mars 2009
// mars 2019 : reprise avec carte grossiere de la France comme pour le DEA 1998

float D=200.0;
int N=8;
float H=0.9;

void setup(){
   size(600,600);
   strokeWeight(1);
}

void draw() {
posit deb, fin, p,q;
float s,r,xm,ym;int i;
 
 
 background(255);
 H = map(mouseY,0,height,0.999,0);
 N = int(map(mouseX,0,width,0,12));
 fill(0);
 text("H:"+str(H),15,15);
 text("N:"+str(N),15,30);
 
 // polygone de depart : France tres approximative
 // les coordonnees sont 20 fois trop grandes pour l'ecran 600x600
 fin=Nouveau(6165.0, 1215.0,null);
 deb=Nouveau(4050.0, 3330.0,fin);
 deb=Nouveau(1485.0, 3420.0,deb);
 deb=Nouveau(1395.0, 4545.0,deb);
 deb=Nouveau(2880.0, 4950.0,deb);
 deb=Nouveau(3735.0, 6930.0,deb);
 deb=Nouveau(3105.0, 9180.0,deb);
 deb=Nouveau(6885.0, 10080.0,deb);
 deb=Nouveau(10350.0, 8235.0,deb);
 deb=Nouveau(9000.0, 5850.0,deb);
 deb=Nouveau(9990.0, 4905.0,deb);
 deb=Nouveau(10215.0, 3015.0,deb);
 deb=Nouveau(6165.0, 1215.0,deb);
 // dessin du polygone original
 stroke(255,0,0);
 p=deb;
 while (p.suiv!=null) {
  line(p.x/20,p.y/20,p.suiv.x/20,p.suiv.y/20);
  p=p.suiv;
 }
 // boucle de subdivision
 randomSeed(1);
 s=sqrt(D*D);
 for(i=1;i<=N;i++){
   p=deb;
   while (p!=fin){
    xm=Normal((p.x+p.suiv.x)/2.0,s); // 0 ou s
    ym=Normal((p.y+p.suiv.y)/2.0,s);   

    //r=Normal(0,s);
    //xm=(p.x + p.suiv.x)/2.0 - r*(p.suiv.y - p.y);
    //ym=(p.y + p.suiv.y)/2.0 + r*(p.suiv.x - p.x);

    
    q=Nouveau(xm,ym,p.suiv);
    p.suiv=q;
    p=q.suiv;
   }
  s /= pow(2.0,H);
 }
 // dessin du polygone apres subdivision
 stroke(0);
 p=deb;
 while (p.suiv!=null) {
  line(p.x/20,p.y/20,p.suiv.x/20,p.suiv.y/20);
  p=p.suiv;
 }

}

class posit {
  float x;
  float y;
  posit suiv;
}

posit Nouveau(float px, float py, posit ps){
  posit n=new posit();
  n.x = px; n.y = py; n.suiv = ps; 
  return n;
}

float Normal(float m, float s) {
  return random(m-1.732*s,m+1.732*s);
  //float theta = random(0,2*PI);
  //float r = sqrt(-2*log(random(0,1)));
  //return m+s*r*cos(theta);
}